// C Source File
// Created 1/1/01
// Updated 12/28/06; 3:08:07 PM

#define DIFF 1
#define HIGH 0

void ClearHallOfFame(char *FileName);
short ScrollNames(char *sptr);
char LevelList(char *FileName);
void SetGlobals(char *FileName);
void ShowLine(char mode,WINDOW w, char level, short ptr, char *vptr, int Attr);
void ShowInfo(char mode,WINDOW w, char level, short ptr, char *vptr,char maxlevel);

void ClearHallOfFame(char *FileName)
{
 unsigned char lev,maxlevel;
 SYM_ENTRY *sym_entry;
 char *sptr,*lptr,*aptr;
	void *LightPlane = malloc(LCD_SIZE);
 memcpy(LightPlane,GetPlane(LIGHT_PLANE),LCD_SIZE);
 AnimateOn=False;
 GrayOff();        //GrayMode(GRAY_OFF);
 if (DlgMessage(FileName,"Clear the Hall of Fame?",BT_OK,BT_CANCEL)==13)
 {
  aptr=charbuffer;
  *aptr=0;
  //while(*++aptr=*FileName++);
  EM_moveSymFromExtMem(SYMSTR(FileName),HS_NULL);    //SYMSTR(FileName) was aptr
  sym_entry=DerefSym(SymFind(SYMSTR(FileName)));     //SYMSTR(FileName) was aptr
  sptr = (char*) HLock(sym_entry->handle);
  maxlevel=sptr[2]-1;
  for (lev=0;lev<=maxlevel;lev++)
  {
   lptr=&sptr[3+FSIZE*lev];
   memset(&lptr[47],0,10);
  }
  HeapUnlock(sym_entry->handle);
  EM_moveSymToExtMem(SYMSTR(FileName),HS_NULL);     //SYMSTR(FileName) was aptr
 }
 GrayOn();        //GrayMode(GRAY_ON);
 memcpy(GetPlane(LIGHT_PLANE),LightPlane,LCD_SIZE);  
 free(LightPlane);
 AnimateOn=True;
}

void SetGlobals(char *FileName)
{
 unsigned char lev,maxlevel;
 SYM_ENTRY *sym_entry;
 char *sptr,*lptr,*aptr;
 unsigned bm,bs,gm,gs;
 void *LightPlane = malloc(LCD_SIZE);
 memcpy(LightPlane,GetPlane(LIGHT_PLANE),LCD_SIZE);
 AnimateOn=False;
 GrayOff();        //GrayMode(GRAY_OFF);
 if (DlgMessage(FileName,"Update Global Records?",BT_OK,BT_CANCEL)==13)
 {
  aptr=charbuffer;
  *aptr=0;
  //while(*++aptr=*FileName++);
  EM_moveSymFromExtMem(SYMSTR(FileName),HS_NULL);     //SYMSTR(FileName) was aptr
  sym_entry=DerefSym(SymFind(SYMSTR(FileName)));      //SYMSTR(FileName) was aptr
  sptr = (char*) HLock(sym_entry->handle);
  maxlevel=sptr[2]-1;
  for (lev=0;lev<=maxlevel;lev++)
  {
  	lptr=&sptr[3+FSIZE*lev];
  	gm=*(unsigned*) &lptr[43];
   gs=*(unsigned*) &lptr[45];
   bm=*(unsigned*) &lptr[47];
   bs=*(unsigned*) &lptr[49];
   if (bm+bs>0 && (gm+gs==0 || gm+gs>bm+bs))
   {
   	*(unsigned*) &lptr[43]=bm;
   	*(unsigned*) &lptr[45]=bs;
   }
  }
  HeapUnlock(sym_entry->handle);
  EM_moveSymToExtMem(SYMSTR(FileName),HS_NULL);       //SYMSTR(FileName) was aptr
 }
 GrayOn();          //GrayMode(GRAY_ON);
 memcpy(GetPlane(LIGHT_PLANE),LightPlane,LCD_SIZE);  
 free(LightPlane);    //this is a modification to fix a memory leak.
 AnimateOn=True;
 }

char LevelList(char *FileName)
{
 short lev;
 SYM_ENTRY *sym_entry;
 char status,*sptr,*aptr,*bptr,*lptr;
 aptr=charbuffer;
 *aptr=0;
 //while(*++aptr=*FileName++);
 sym_entry=DerefSym(SymFind(SYMSTR(FileName)));   //SYMSTR(FileName) was aptr
 sptr = (char*) HLock(sym_entry->handle);
 memset(charbuffer,32,78);
 charbuffer[78]=0;
 lev=ScrollNames(sptr);
 if (lev>=0)
 {
  lptr=&sptr[3+FSIZE*lev];
  difficulty= *lptr;
  aptr=&lptr[1];
  bptr=&title[0];
  while (*bptr++=*aptr++);
  aptr=&lptr[22];
  bptr=&author[0];
  while (*bptr++=*aptr++);
  aptr=&lptr[51];
  bptr=&champ[0];
  while (*bptr++=*aptr++);
  GlobalMoves=*(unsigned*) &lptr[43];
  GlobalShots=*(unsigned*) &lptr[45];
  BestMoves=*(unsigned*) &lptr[47];
  BestShots=*(unsigned*) &lptr[49];
  status=1; 	
  memmove(board,&lptr[58],192);
  Level=lev;
 }
 else
  status=0;
 HeapUnlock(sym_entry->handle);
 return status;
}

short ScrollNames(char *sptr)
{
 unsigned char maxlevel,level,done,KeyUsed,cspot;
 short key,ptr;
 char *vptr;
 char mode,delta;
 WINDOW w;
 mode=DIFF;
 WinOpen(&w,MakeWinRect(tx,ty-1,tx+156,ty+90),WF_SAVE_SCR);
 WinActivate(&w);
 WinFont(&w,F_6x8);
 WinMoveTo(&w,0,10);
 WinLineRel(&w,152,0);
 WinMoveTo(&w,0,18);
 WinLineRel(&w,152,0);
 WinMoveTo(&w,0,80);
 WinLineRel(&w,152,0);
 WinStrXY(&w,22,2,"LASER TANK LEVELS");
 ST_busy(ST_NORMAL);
 ST_refDsp(3);
 maxlevel=sptr[2]-1;
 level=(Level/10)*10;
 done = 0;
 ptr=Level;
 WinFont(&w,F_4x6);
 if (mode==DIFF)
  WinStrXY(&w,1,12,"Lev    Level Name               Dif          Author");
 else
  WinStrXY(&w,1,12,"Lev    Level Name              Champ    Mvs  Shts");
 WinStrXY(&w,1,82,"Use 0-9 & 2nd[0-9] & \x7F[0-9]");
 WinStrXY(&w,104,82,"File:");
 WinStrXY(&w,120,82,LevFile);
 vptr=&sptr[3+FSIZE*level];
 ShowInfo(mode,w,level,ptr,vptr,maxlevel);
 vptr=&sptr[3+FSIZE*ptr];
 while (!done)
 {
  key=GetKey();
  ST_busy(ST_NORMAL);
  ST_refDsp(3);
  if (key>=48 && key<=57)
  {
   if (10*(key-48)<=maxlevel)
   {
    level=10*(key-48);
    vptr=&sptr[3+FSIZE*level];
    ptr=level;
    ShowInfo(mode,w,level,ptr,vptr,maxlevel);
   }  
  }
  else
  {
  	cspot=0;
  	KeyUsed=True;
   switch (key)
   {
   	case 60: cspot=100; break;
   	case 34: cspot=110; break;
   	case 92: cspot=120; break;
   	case 4147: cspot=130; break;
   	case 58: cspot=140; break;
   	case 4149: cspot=150; break;
   	case 4150: cspot=160; break;
   	case 4151: cspot=170; break;
   	case 4152: cspot=180; break;
   	case 59: cspot=190; break;
   	default: KeyUsed=False;
   }
   if (KeyUsed)
   {
    if (cspot<=maxlevel)
    {
     level=cspot;
     vptr=&sptr[3+FSIZE*level];
     ptr=level;
     ShowInfo(mode,w,level,ptr,vptr,maxlevel);
    }
   }  
   else
    if (key>=DIAM_0 && key<=DIAM_9)
    {
     delta=key-DIAM_0;
     delta=delta-level%10;
     delta = (delta>=0) ? delta : delta+10;
     if (level+delta<=maxlevel)
     {
      ptr=level+delta;
      done=1;
     }
    }
    else
     switch (key)
     {
      case 13:
       done=1;break;
      case 264:
       done=1;ptr=-1;break;
      case CURS_LT:
       if (mode==HIGH)
       {
        mode=DIFF;
        WinAttr(&w,A_REPLACE);
        WinStrXY(&w,1,12,charbuffer);
        WinStrXY(&w,1,12,"Lev    Level Name               Dif          Author");
        vptr=&sptr[3+FSIZE*level];
        ShowInfo(mode,w,level,ptr,vptr,maxlevel);
        vptr=&sptr[3+FSIZE*ptr];
       }
       break;
      case CURS_RT:
       if (mode==DIFF)
       {
        mode=HIGH;
        WinAttr(&w,A_REPLACE);
        WinStrXY(&w,1,12,charbuffer);
        WinStrXY(&w,1,12,"Lev    Level Name              Champ    Mvs  Shts");
        vptr=&sptr[3+FSIZE*level];
        ShowInfo(mode,w,level,ptr,vptr,maxlevel);
        vptr=&sptr[3+FSIZE*ptr];
       }
       break;
      case CURS_DN:
       if (ptr<maxlevel)
       {		 
        if (ptr<level+9)
        {
         ShowLine(mode,w,level,ptr,vptr,A_REPLACE);
       	 ptr++; 
         vptr+=FSIZE;
       	 ShowLine(mode,w,level,ptr,vptr,A_REVERSE);
       	}
       	else
       	{
         ShowLine(mode,w,level,ptr,vptr,A_REPLACE);
       	 WinScrollV(&w,MakeWinRect(1,20,152,79),6);
       	 level++;
       	 ptr++;
       	 vptr+=FSIZE;
       	 ShowLine(mode,w,level,ptr,vptr,A_REVERSE);
        }
       }
       break;
      case CURS_UP:
       if (ptr>0)
       {
       	if (ptr>level)	
       	{
       	 ShowLine(mode,w,level,ptr,vptr,A_REPLACE);
         ptr--;
       	 vptr-=FSIZE;
       	 ShowLine(mode,w,level,ptr,vptr,A_REVERSE); 
       	}
       	else
        {
       	 ShowLine(mode,w,level,ptr,vptr,A_REPLACE);
       	 WinScrollV(&w,MakeWinRect(1,20,152,79),-6);
       	 level--;
       	 ptr--;
       	 vptr-=FSIZE;
       	 ShowLine(mode,w,level,ptr,vptr,A_REVERSE);
        }
       }
       break;
      }
     }
    }
 WinClose(&w);
 return ptr;
}

void ShowLine(char mode,WINDOW w,char level, short ptr, char *vptr, int Attr)
{
 char num[]="        "; //8 spaces;
 unsigned score;
 WinAttr(&w,Attr);
 sprintf(num,"%03u",ptr);
 WinStrXY(&w,0,20+6*(ptr-level),charbuffer);
 WinStrXY(&w,1,20+6*(ptr-level),num);
 WinStrXY(&w,16,20+6*(ptr-level),&vptr[1]); 
 if (mode==DIFF)
 {
  WinStrXY(&w,89,20+6*(ptr-level),&dif[(*vptr)*8]);
  WinStrXY(&w,118,20+6*(ptr-level),&vptr[22]);
 }
 else
 {
  WinStrXY(&w,89,20+6*(ptr-level),&vptr[51]);
  score = *(unsigned*) &vptr[47];
  sprintf(num,"%4u",score);
  WinStrXY(&w,118,20+6*(ptr-level),num);
  score = *(unsigned*) &vptr[49];
  sprintf(num,"%4u",score);
  WinStrXY(&w,136,20+6*(ptr-level),num);
 }
}

void ShowInfo(char mode,WINDOW w, char level, short ptr, char *vptr,char maxlevel)
{
 int i;
 for (i=level;i<=level+9;i++)
 {
  if (i<=maxlevel)	
  {
   if (i==ptr)
    ShowLine(mode,w,level,i,vptr,A_REVERSE);
   else
    ShowLine(mode,w,level,i,vptr,A_REPLACE);
   vptr+=FSIZE;
  }
  else
  {
   WinAttr(&w,A_REPLACE);
   WinStrXY(&w,0,20+6*(i-level),charbuffer); 	
  }
 }  
}


